import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import React from "react";
import { Box, Flex, Text, Container, MenuButton, IconButton, MenuList, MenuItem, Menu, Stack, HStack, Portal, Show, useBreakpointValue, MenuDivider, } from "@chakra-ui/react";
import { Link, useParams } from "react-router-dom";
import { RuntimeContext } from "../RuntimeContext";
import { HamburgerIcon } from "@chakra-ui/icons";
import { useNavigations } from "../hooks/navigations";
import { useComposer } from "../Composer";
const TopbarLayout = ({ children }) => {
    const appName = RuntimeContext.useSelectState((state) => state.app.name);
    const params = useParams();
    const isSm = useBreakpointValue([true, false, false, false]);
    const composer = useComposer();
    const navigations = useNavigations();
    const dropdownRef = React.useRef();
    return (_jsxs(Box, { children: [_jsx(Box, Object.assign({ bgColor: "surface.900", shadow: "base", zIndex: "1", position: "sticky", top: 0 }, { children: _jsxs(Container, Object.assign({ maxW: "container.lg" }, { children: [_jsxs(Flex, Object.assign({ height: 16, alignItems: "center", justifyContent: "space-between" }, { children: [_jsx(Text, Object.assign({ fontWeight: "bold", fontSize: "md" }, { children: appName })), _jsx(Box, Object.assign({ display: { sm: "none", md: "initial" } }, { children: _jsx(Stack, Object.assign({ spacing: 8, align: "center", justify: ["center", "space-between", "flex-end", "flex-end"], direction: ["column", "row", "row", "row"], pt: [4, 4, 0, 0] }, { children: navigations.navigations.map((navigation) => (_jsx(HStack, Object.assign({ cursor: "pointer", spacing: 2, as: Link, to: `/page/${navigation.id}` }, { children: _jsx(Text, Object.assign({ color: params.page === navigation.id
                                                    ? "qore.primary"
                                                    : "text.900", fontSize: "reg", fontWeight: "normal" }, { children: navigation.title })) }), navigation.id))) })) })), isSm || navigations.menus.length > 0 ? (_jsx(Box, { children: _jsxs(Menu, Object.assign({ autoSelect: false }, { children: [_jsx(MenuButton, { as: IconButton, "aria-label": "Options", icon: _jsx(HamburgerIcon, {}), variant: "outline" }), _jsx(Portal, Object.assign({ containerRef: dropdownRef }, { children: _jsxs(MenuList, { children: [_jsxs(Show, Object.assign({ below: "sm" }, { children: [navigations.navigations.map((nav) => (_jsx(Link, Object.assign({ to: `/page/${nav.id}`, onClick: () => composer.setExitDirection("none") }, { children: _jsx(MenuItem, { children: _jsx(Text, Object.assign({ color: params.page === nav.id
                                                                                ? "qore.primary"
                                                                                : "text.900" }, { children: nav.title })) }) }), nav.id))), navigations.navigations.length +
                                                                    navigations.menus.length >
                                                                    0 && _jsx(MenuDivider, {})] })), navigations.menus.map((menu) => (_jsx(Link, Object.assign({ to: `/page/${menu.id}`, onClick: () => composer.setExitDirection("none") }, { children: _jsx(MenuItem, { children: _jsx(Text, Object.assign({ color: params.page === menu.id
                                                                        ? "qore.primary"
                                                                        : "text.900" }, { children: menu.title })) }) }), menu.id)))] }) }))] })) })) : null] })), _jsx(Box, { ref: dropdownRef })] })) })), _jsx(Box, Object.assign({ position: "absolute", left: "50%", right: 0, top: 16, bottom: 0, transform: "translate(-50%)", w: "full", h: "full", overflow: "hidden" }, { children: children }))] }));
};
export default TopbarLayout;
//# sourceMappingURL=TopbarLayout.js.map